#!/usr/bin/perl -w

use CGI::Pretty qw/-compile -nosticky :standard *pre *table map :html3 -private_tempfiles -oldstyle_urls/;
use CGI::Carp qw(fatalsToBrowser);
use strict;

use IPC::Run qw(start finish run pump);
use IO::Socket;

use File::Temp qw/tempfile tempdir/ ;
use File::Basename;

##$ENV{PATH} = '/bin:/usr/bin/:/usr/local/bin';

local our $query = new CGI::Pretty;

######################################################################
## Configuration

## Following variables set by ./configure
our $PACKAGE = 'frmg';
our $htmldir = '/var/www/perl/frmg';

######################################################################
## Reading parameters

our ($tree) = $query->param(-name=>'id');

######################################################################
## Emitting forms

## Otherwise emit form:

our $STYLE=<<END;
<!--
    BODY {background-color: linen;}
-->
END

print 
  header,
  start_html( -title => 'Browsing grammar',
	      -style => { -code => $STYLE },
	      -style => { -src => 'style.css' }
	    ),
  h1('Browsing grammar '.$PACKAGE),
  start_form,
  p('Enter tree id or search word',
    textfield( -name=> 'id', -size=>30, -maxlength=>30 ),
    ' ( use * to get the whole grammar ) '
   ),
  a({href=>"index.html"},"Browse the meta grammar"),
  end_form,
  hr;

$tree =~ s/^\s+//og;

if ($tree ne '') {
  ## process request
  ##  print "Looking for tree $tree\n";
  process_tree($tree);
  ## exit;
}

print hr,
  end_html;

######################################################################


sub process_tree {
  my $tree = shift;

  my @params = ();
  if ($tree =~ /^\d+$/) {
    push(@params,'--stringparam','this',"$tree");
  } elsif ($tree ne '*') {
    push(@params,'--stringparam','search',"$tree");
  }

  my @extract =
    ('/usr/bin/xsltproc',@params,"$htmldir/extract.xsl",'-');
  my @html=
    ('/usr/bin/xsltproc','--stringparam','simple','yes',"$htmldir/tagml2html.xsl",'-' );
  
  my $h;

  if (@params) {
    $h  = start \@extract,
      "<$htmldir/frgram.tag.xml",
	'|', \@html, '>pipe',\*OUT;
  } else {
    $h  = start \@html,
      "<$htmldir/frgram.tag.xml",
	'>pipe',\*OUT;
  }

  print <OUT>;
  close OUT;
  finish $h;
}

